program flightline;

(* routine to read time-sorted LIDAR returns and break into flight-line segments 
         1         2         3         4         5         6         7
12345678901234567890123456789012345678901234567890123456789012345678901234567890

1085030.77 354714.55 1611.02 1544.38 582488.757740 1   0.36   2.42 1100
1085029.10 354716.06 1554.66 1488.02 582488.757740 2   0.36   2.42 1100
1085033.15 354720.32 1612.60 1545.96 582488.757788 1   0.45   2.46 1100
1085031.01 354722.57 1542.36 1475.71 582488.757788 2   0.45   2.46 1100
*)

#include '/gs1/rah/pascal_lib/str_to_num.pas'

type
  string255 = varying[255] of char;
  string10 = varying[10] of char;

var
  inflname : string255;
  aline, bline : string255;
  fs : array[1..17] of char;
  fsfx : string255;
  asec, bsec : real;
  n, nlines : integer;
  aweek, bweek : string10;
  infl, ofl : text;


begin
  argv(1,inflname);
  fs[1] := '1'; fs[2] := '2'; fs[3] := '3'; fs[4] := '4'; fs[5] := '5'; fs[6] := '6'; fs[7] := '7'; fs[8] := '8'; fs[9] := '9';
  n := 1;
  reset(infl, inflname);
  readln(infl,aline);
  asec := StrToDouble(CutBlanks(substr(aline,37,24)));
  if length(aline) = 71 then aweek := CutBlanks(substr(aline,68,4)) else aweek := CutBlanks(substr(aline,69,4));
  rewrite(ofl, concat(inflname,'1'));
  writeln(ofl,aline);
  nlines := 1;
  while not eof(infl) do
    begin
      bline := aline; bsec := asec; bweek := aweek;
      repeat
        readln(infl,aline);
      until (aline <> bline) or eof(infl);  
      asec := StrToReal(CutBlanks(substr(aline,38,10))); 
      if length(aline) = 71 then aweek := CutBlanks(substr(aline,68,4)) else aweek := CutBlanks(substr(aline,69,4));
      if (asec-bsec < 2)  and (aweek = bweek) then 
        begin
          writeln(ofl,aline);
          nlines := nlines + 1;
        end
      else
        begin
          writeln(asec-bsec, ' ',aweek,' ',bweek, ' ',length(aline),' ',length(bline));
          writeln(bline,' ', length(bline));
          writeln(aline,' ', length(aline));
          writeln;
          if nlines > 2 then n := n+1; if n = 10 then halt;
            close(ofl);
          nlines := 0;   
          rewrite(ofl, concat(inflname,fs[n]));
          writeln(ofl,aline);
        end
      end;
 


end.
